#!/bin/bash

#Maujy, 2004/4/21
#date MMDDHHmmYear
date 010100002000 

#
#
# Char Device Name             Major    Minor 
#---------------------------------------------
#
#  ppp                         108      0     
#  isecpdri                    127      0
#  pppoe                       200      0
#  tcpmssmangler               202      0
#  wlanpdrv                    131      0


mknod /dev/ppp            c        108 0
mknod /dev/isecpdri       c        127 0
mknod /dev/pppoe          c        200 0
mknod /dev/tcpmssmangler  c        202 0
mknod /dev/wlanpdrv       c        131 0
#Chuck
mknod /dev/gpioCtl        c        250 0

echo "Mounting ramd for firmware upgrade...."
mkdir -p /mnt/ramd
mount -n -t ramfs none /mnt/ramd -o maxsize=6000
mount -n -t devpts none /dev/pts -o igd=5, mode=620 

echo "Mounting JFFS2 partition...."
mkdir -p /mnt/jffs2
mount -n -t jffs2 /dev/mtdblock2 /mnt/jffs2 > /mnt/ramd/log_jffs2 2>&1
if [ -s /mnt/ramd/log_jffs2 ]; then
   /mnt/cramfs/eraseall /dev/mtd2
   mount -n -t jffs2 /dev/mtdblock2 /mnt/jffs2
fi
mkdir -p /mnt/jffs2/igateway
mkdir -p /mnt/jffs2/igateway/config
mkdir -p /mnt/jffs2/igateway/certs

echo "start zcomlog..."
insmod /mnt/cramfs/igateway/zcomlog.o

echo "loading csr & ethernet drivers..."

#Chuck add this delay for MVL 3.0 MAC issue on 20040111
sleep 2
 
insmod /mnt/cramfs/csr.o
insmod /mnt/cramfs/ixp425_eth.o

#Maujy
#ifconfig ixp0 172.16.2.252 netmask 255.255.255.0
ifconfig lo   127.0.0.1    netmask 255.0.0.0

#Maujy, 2003/11/13
ln -s /mnt/cramfs/igateway/lib/libsnmp.so /lib/libsnmp.so

ln -s /mnt/cramfs/igateway/lib/libigwifconfig.so /lib/libigwifconfig.so
ln -s /mnt/cramfs/igateway/lib/libigwopssl.so /lib/libigwopssl.so
#Chuck
#ln -s /mnt/cramfs/igateway/html /igateway/html
cp -r /mnt/cramfs/igateway/html /mnt/ramd/

#Maujy, 2004/4/21
cp /mnt/cramfs/igateway/htpscert /igateway/certs/
chmod 600 /igateway/certs/htpscert 

#Maujy, 2003/12/12 marked ip_forward
#echo 1 > /proc/sys/net/ipv4/ip_forward

#Maujy
mkdir /etc/ssh
cp /mnt/cramfs/igateway/sshd_config /etc/ssh/ 
cp /mnt/cramfs/igateway/ssh_host_key /etc/ssh/ 
cp /mnt/cramfs/igateway/ssh_host_dsa_key /etc/ssh/ 
cp /mnt/cramfs/igateway/ssh_host_rsa_key /etc/ssh/ 
chmod 600 /etc/ssh/sshd_config
chmod 600 /etc/ssh/ssh_host_key
chmod 600 /etc/ssh/ssh_host_dsa_key
chmod 600 /etc/ssh/ssh_host_rsa_key

cd /mnt/cramfs/igateway

#Chuck
echo "Inserting Wireless Driver Module"
insmod ag621pci.o
#ifconfig eth0 192.168.0.200 netmask 255.255.255.0
ifconfig eth0 up

echo "Inserting iGateway Kernel Module"
insmod igateway.o

#insmod atherospci.o

#echo "Inserting iGateway PPPoE Module (Make sure ppp_generic.o IS LOADED before this)"
#insmod drvpppoe.o
#insmod tcpmssmangler.o

insmod wlanpsudrv.o
ifconfig sap0 up

#Maujy move dhcpc before ldsv to fix the dhcp discovery packet issue
./dhcpc &

#Maujy move the ldsv save from daemon execution
echo "Loading iGateway Database"
./ldsv -l

./wag302server &

./httpd &
./dhcpd &
./ddns &
./dnsrd &
#Maujy, 2003/12/12 marked rip
#./rip &
./wan &
./sshd &
./snmpd &
./radius &
./igw8021x &

#Maujy
./wins &

#Chuck
insmod gpioCtl.o
./dfbutton &

./vsftpd

sleep 2
/mnt/cramfs/igateway/wag302cli

echo "iGateway Initialization finished ..."

